#include "util.h"
#include "utilapi.h"
#include "bmmlib.h"
#include "stdmat.h"
#include "iparamb2.h"
#include <windows.h>
#include <math.h>
#include "ProgressDialog.h"

static BOOL CALLBACK ProgressDlgProc(HWND hWnd, UINT msg, 
									 WPARAM wParam, LPARAM lParam);

CProgress *theProgress;

CProgress::CProgress(HWND parent)
{
	cancelPressed = FALSE;
	dlg = CreateDialog(hInstance, MAKEINTRESOURCE(IDD_PROGRESS_DIALOG), parent, ProgressDlgProc);
	ShowWindow(dlg, SW_SHOW);
}

CProgress::~CProgress()
{

}

void CProgress::Init(HWND hWnd)
{
	HWND tWnd;
	tWnd = GetDlgItem(hWnd, IDC_PROGRESS_MESSAGE);
	SetWindowText(tWnd, _T("I'm Initialized"));
//	RedrawWindow(tWnd, NULL, NULL, RDW_ERASE | RDW_INVALIDATE);
}

void CProgress::Destroy(HWND hWnd)
{
}

void CProgress::Close()
{
	DestroyWindow(dlg);
}

static BOOL CALLBACK ProgressDlgProc(HWND hWnd, UINT msg, 
									 WPARAM wParam, LPARAM lParam)
{
	switch (msg) {
		case WM_INITDIALOG:
			theProgress->Init(hWnd);
			break;
		
		case WM_DESTROY:
			theProgress->Destroy(hWnd);
			break;

		case WM_COMMAND:
			switch (LOWORD(wParam)) 
			{
				case IDCANCEL:
					theProgress->Close();
					theProgress->cancelPressed = TRUE;
					break;				
		
			}
			break;

		default:
			return FALSE;
		}
	return TRUE; 
}
